#include <iostream.h>
#include <conio.h>
#include <iomanip.h>
const int N= 5;
const int MAX = 100;
int D[N+1][N+1]={0},P[N+1][N+1]={0};
int W[N+1][N+1]={{0},{0,0,1,MAX,1,5},{0,9,0,3,2,MAX},{0,MAX,MAX,0,4,MAX},
				{0,MAX,MAX,2,0,3},{0,3,MAX,MAX,MAX,0}};

void Copy(int To [][N+1],int From [][N+1]){
   for (int i = 1 ; i<= N ; i ++)
   	for (int j = 1 ; j<= N ; j ++)
      	To[i][j] = From[i][j];
}

void print (int A[][N+1]){
    for (int i = 1; i <= N; i++){
       for (int j = 1; j <= N; j++)
       	cout << setw(5) << A[i][j] ;
       cout << endl;
    }
}

void floyd2 (){
  int i, j, k;
  Copy(D , W);
  for (k = 1; k <= N; k++)
      for(i = 1; i <= N; i++)
         for(j = 1; j <= N; j++)
             if (D[i][k] + D[k][j] < D[i][j]){
                P[i][j] = k;
                D[i][j] = D[i][k] + D[k][j];
              }
}
void path (int q, int r){
  if (P[q][r] != 0) {
		path (q, P[q][r]);
   	cout << "v" << P[q][r]<< " -> ";
  		path (P[q][r], r);
    }
 }


void main(){
   floyd2();
   cout << endl<< "W:"<< endl; print(W);
	cout << endl<< "D:"<< endl; print(D);
   cout << endl<< "P:"<< endl; print(P);
   for(int i = 1; i <= N; i++)
      for(int j = 1; j <= N; j++){
         cout << "v" << i <<" -> ";
         path(i,j) ;
         cout << "v" << j <<endl;
      }
   getch();
}
